<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmCpu: ReadMe</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">kmCpu
   </div>
   <div id="projectbrief">kmCpu library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('md__x_1__r_e_a_d_m_e.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">ReadMe </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1>kmCpu library for AVR MCUs</h1>
<p>The kmCPU library offers a set of functions to control CPU operations and peripherals on AVR MCUs</p>
<h2>Table of Contents</h2>
<ul>
<li><a href="#version-history">Version History</a></li>
<li><a href="#overview">Overview</a></li>
<li><a href="#dependencies">Dependencies</a></li>
<li><a href="#usage">Usage</a></li>
<li><a href="#example-code">Example Code</a></li>
<li><a href="#author-and-license">Author and License</a></li>
</ul>
<h2>Version History</h2>
<p>v1.0.0 Initial (2024-05-25)</p>
<h2>Overview</h2>
<p>Includes:</p><ul>
<li>Functions to enable and disable interrupts (<code><a class="el" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable()</a></code>, <code><a class="el" href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">kmCpuInterruptsDisable()</a></code>).</li>
<li>Watchdog management functions to enable, disable, and reset the watchdog timer (<code>kmCpuWatchdogEnable()</code>, <code>kmCpuWatchdogDisable()</code>, <code>kmCpuWatchdogReset()</code>).</li>
<li>Additional functions for halting the CPU (<code><a class="el" href="km_cpu_8h.html#a2cab7faaa3a7f692118e494d9bdca404">kmCpuHalt()</a></code>), performing a soft reset (<code><a class="el" href="km_cpu_8h.html#accc2b1261d0ba57b5dbf5476482f9534">kmCpuSoftReset()</a></code>), and disabling watchdog and interrupts on startup (<code><a class="el" href="km_cpu_8h.html#ae403db6f1fe7e2bc5f6e0319c340fbf4">kmCpuDisableWatchdogAndInterruptsOnStartup()</a></code>).</li>
</ul>
<h2>Dependencies</h2>
<ul>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs/kmCommon">kmCommon</a></li>
</ul>
<h2>Usage</h2>
<p>Getting this library and adding it to own project:</p><ul>
<li>To add this module to own project as submodule - enter the main directory of the source code and use git command</li>
</ul>
<div class="fragment"><div class="line">git submodule add git@gitlab.com:c-mos/kmAvrLibs/kmCpu.git kmCpu</div></div><!-- fragment --><ul>
<li>After cloning own application from git repository use following additional git command to get correct revision of submodule: <div class="fragment"><div class="line">git submodule update --init</div></div><!-- fragment --></li>
</ul>
<h3>Interrupt Control</h3>
<p>Use the functions <code><a class="el" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable()</a></code> and <code><a class="el" href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">kmCpuInterruptsDisable()</a></code> to respectively enable and disable interrupts.</p>
<h3>Watchdog Management</h3>
<p>Manage the watchdog timer using the functions <code>kmCpuWatchdogEnable()</code>, <code>kmCpuWatchdogDisable()</code>, and <code>kmCpuWatchdogReset()</code> to enable, disable, and reset the watchdog timer.</p>
<h3>CPU Operations</h3>
<p>Utilize functions like <code><a class="el" href="km_cpu_8h.html#a2cab7faaa3a7f692118e494d9bdca404">kmCpuHalt()</a></code> to halt the CPU, <code><a class="el" href="km_cpu_8h.html#accc2b1261d0ba57b5dbf5476482f9534">kmCpuSoftReset()</a></code> to perform a software reset, and <code><a class="el" href="km_cpu_8h.html#ae403db6f1fe7e2bc5f6e0319c340fbf4">kmCpuDisableWatchdogAndInterruptsOnStartup()</a></code> to disable watchdog and interrupts on startup.</p>
<p>## Example Code </p><div class="fragment"><div class="line"><span class="preprocessor">#include &quot;kmCommon/kmCommon.h&quot;</span></div><div class="line"></div><div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>) {</div><div class="line">    <span class="comment">// Init interrupts and watchdog</span></div><div class="line">    <a class="code" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable</a>();</div><div class="line">    kmCpuWatchdogEnable(WDTO_2S);</div><div class="line"></div><div class="line">    <span class="keywordflow">while</span> (<span class="keyword">true</span>) {</div><div class="line">        kmCpuWatchdogReset();</div><div class="line">    }</div><div class="line">}</div></div><!-- fragment --><h2>Author and License</h2>
<p>Author: Krzysztof Moskwa</p>
<p>e-mail: chris[dot]moskva[at]gmail[dot]com</p>
<p>Software License: GNU General Public License (GPL) version 3.0 or later. See <a href="https://www.gnu.org/licenses/gpl-3.0.txt">LICENSE.txt</a></p>
<img src="https://www.gnu.org/graphics/gplv3-or-later-sm.png" alt="GPL3 Logo" class="inline"/>
 </div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.15 </li>
  </ul>
</div>
</body>
</html>
